package main

import (
	"fmt"
	"sync"
	"sync/atomic"
)

func main() {
	var sum int32
	group := &sync.WaitGroup{}

	add := func(group *sync.WaitGroup) {
		defer group.Done()
		for i := 0; i < 100; i++ {
			atomic.AddInt32(&sum, int32(i))
		}
	}
	diff := func(group *sync.WaitGroup) {
		defer group.Done()
		for i := 0; i < 100; i++ {
			atomic.AddInt32(&sum, int32(-i))
		}
	}

	for i := 0; i < 5; i++ {
		group.Add(2)
		go add(group)
		go diff(group)
	}

	group.Wait()
	fmt.Println(sum)
}
